/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wawi.gui.admingui.gui;

import java.awt.Color;

import java.util.Iterator;
import java.util.List;
import static javax.swing.JOptionPane.showMessageDialog;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import wawi.fachlogik.adminsteuerung.grenz.ProduktGrenz;
import wawi.fachlogik.adminsteuerung.steuer.ProduktSteuerung;

import wawi.gui.admingui.resources.MyListModelProduktShow;

/**
 *
 * @author Anton
 */
public class FrameProduktShow extends javax.swing.JFrame {

    private ProduktSteuerung prodsteuerung;
    private int hiddenValueForProdukt;
    private MyListModelProduktShow mylistmodelproduktshow;
    //private List<ProduktGrenz> produktgrenzlist;
    private List<ProduktGrenz> produktgrenzliste;
    private String flag;
    private int merker;
    private static List<ProduktGrenz> produktgrenzlisteAktivDeaktiv;

    /**
     * Creates new form FrameProduktShow
     */
    public FrameProduktShow() {
        initComponents();
    }

    public static void setProduktgrenzlisteAktivDeaktiv(List<ProduktGrenz> produktgrenzlisteAktivDeaktiv) {
        FrameProduktShow.produktgrenzlisteAktivDeaktiv = produktgrenzlisteAktivDeaktiv;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton2 = new javax.swing.JButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(32767, 32767));
        Tabelle = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        Produkte = new javax.swing.JLabel();
        Stueckzahl = new javax.swing.JLabel();
        fieldById = new javax.swing.JTextField();
        close = new javax.swing.JButton();
        aktivierenProdukt = new javax.swing.JButton();
        deaktivierenProdukt = new javax.swing.JButton();
        jComboBox1 = new javax.swing.JComboBox<>();
        filterbyStueckzahl = new javax.swing.JButton();
        Ausgabe = new javax.swing.JLabel();
        lblOutput = new javax.swing.JLabel();

        jButton2.setText("jButton2");

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        prodsteuerung = new ProduktSteuerung();
        List<ProduktGrenz> produktgrenzliste = prodsteuerung.produktAnzeigen();
        MyListModelProduktShow mylistmodelproduktshow = new MyListModelProduktShow();
        mylistmodelproduktshow.setProduktgrenzlist(produktgrenzliste);
        jTable1.setModel(mylistmodelproduktshow.buildTableModel());
        jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener(){
            public void valueChanged(ListSelectionEvent event) {
                // http://stackoverflow.com/questions/10128064/jtable-selected-row-click-event
                // print first column value from selected row
                // zeigt die ID des ausgewählten(angeklickten) Produkts an
                String val = jTable1.getValueAt(jTable1.getSelectedRow(), 0).toString();
                hiddenValueForProdukt = Integer.parseInt(val);
                lblOutput.setText("Produkt : "+hiddenValueForProdukt);
            }
        });
        //http://stackoverflow.com/questions/1990817/how-to-make-a-jtable-non-editable
        // man kann die einträgen nicht verändern
        for (int c = 0; c < jTable1.getColumnCount(); c++)
        {
            Class<?> col_class = jTable1.getColumnClass(c);
            jTable1.setDefaultEditor(col_class, null);        // remove editor
        }
        /* Listener Event aus Google */
        Tabelle.setViewportView(jTable1);

        Produkte.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        Produkte.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        Produkte.setText("Produkte");

        Stueckzahl.setText("Stückzahl:");

        close.setText("Schließen");
        close.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeActionPerformed(evt);
            }
        });

        aktivierenProdukt.setText("Aktivieren");
        aktivierenProdukt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aktivierenProduktActionPerformed(evt);
            }
        });

        deaktivierenProdukt.setText("Deaktivieren");
        deaktivierenProdukt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                deaktivierenProduktActionPerformed(evt);
            }
        });

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "kleiner als", "groesser als", "gleich" }));
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });

        filterbyStueckzahl.setText("Filtern");
        filterbyStueckzahl.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filterbyStueckzahlActionPerformed(evt);
            }
        });

        Ausgabe.setText("Ausgabe:");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(362, 362, 362)
                .addComponent(Produkte, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(360, 360, 360))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 130, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(39, 39, 39)
                        .addComponent(Stueckzahl)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(fieldById, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(10, 10, 10)
                        .addComponent(filterbyStueckzahl, javax.swing.GroupLayout.PREFERRED_SIZE, 92, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(108, 108, 108)
                        .addComponent(aktivierenProdukt, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(deaktivierenProdukt, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 92, Short.MAX_VALUE)
                        .addComponent(close, javax.swing.GroupLayout.PREFERRED_SIZE, 112, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(Ausgabe)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblOutput, javax.swing.GroupLayout.PREFERRED_SIZE, 353, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(Tabelle)
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {aktivierenProdukt, close, deaktivierenProdukt, filterbyStueckzahl});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(Produkte, javax.swing.GroupLayout.PREFERRED_SIZE, 33, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(Tabelle, javax.swing.GroupLayout.DEFAULT_SIZE, 449, Short.MAX_VALUE)
                .addGap(27, 27, 27)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(aktivierenProdukt)
                        .addComponent(deaktivierenProdukt)
                        .addComponent(close))
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(filterbyStueckzahl)
                        .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(Stueckzahl)
                        .addComponent(fieldById, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(Ausgabe)
                    .addComponent(lblOutput, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(24, 24, 24))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void closeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeActionPerformed
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        dispose();
    }//GEN-LAST:event_closeActionPerformed

    private void filterbyStueckzahlActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filterbyStueckzahlActionPerformed

        if (fieldById.getText().equals("")) {
            showMessageDialog(null, "Geben Sie eine Stückzahl ein!");
            lblOutput.setText("Fehler!");
        } else {
            merker = 1;
            // JTable1 deklarieren
            jTable1 = new javax.swing.JTable();
            prodsteuerung = new ProduktSteuerung();

            hiddenValueForProdukt = Integer.parseInt(fieldById.getText());

            flag = jComboBox1.getSelectedItem().toString();
            produktgrenzliste = prodsteuerung.produktAnzeigenByStueckzahl(hiddenValueForProdukt, flag);
            mylistmodelproduktshow = new MyListModelProduktShow();

            mylistmodelproduktshow.setProduktgrenzlist(produktgrenzliste);
            jTable1.setModel(mylistmodelproduktshow.buildTableModel());
            /* Listener Event aus Google */

            jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent event) {
                    // http://stackoverflow.com/questions/10128064/jtable-selected-row-click-event
                    // print first column value from selected row
                    String val = jTable1.getValueAt(jTable1.getSelectedRow(), 0).toString();

                    hiddenValueForProdukt = Integer.parseInt(val);
                    lblOutput.setText("Produkt : " + hiddenValueForProdukt);
                }
            });

            //http://stackoverflow.com/questions/1990817/how-to-make-a-jtable-non-editable
            // man kann die einträgen nicht verändern
            for (int c = 0; c < jTable1.getColumnCount(); c++) {
                Class<?> col_class = jTable1.getColumnClass(c);
                jTable1.setDefaultEditor(col_class, null);        // remove editor
            }
            /* Listener Event aus Google */

        }

        Tabelle.setViewportView(jTable1);


    }//GEN-LAST:event_filterbyStueckzahlActionPerformed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed

// TODO add your handling code here:
    }//GEN-LAST:event_jComboBox1ActionPerformed

    private void aktivierenProduktActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aktivierenProduktActionPerformed
        // TODO add your handling code here:

        boolean ret = false;
        if (merker == 1) {
            ProduktSteuerung ps = new ProduktSteuerung();
            ret = ps.produktStatusAktiv(produktgrenzliste);
            if (ret) {
                lblOutput.setForeground(Color.BLACK);
                lblOutput.setText(produktgrenzlisteAktivDeaktiv.size() + " Einträge wurden erfolgreich aktiviert");
            } else {
                lblOutput.setForeground(Color.red);
                lblOutput.setText("Nicht zulässig!");
            }

        } else {
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Nicht zulässig!");
        }


    }//GEN-LAST:event_aktivierenProduktActionPerformed

    private void deaktivierenProduktActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_deaktivierenProduktActionPerformed
        // TODO add your handling code here:
        boolean ret = false;
        if (merker == 1) {
            ProduktSteuerung ps = new ProduktSteuerung();
            ret = ps.produktStatusInaktiv(produktgrenzliste);
            if (ret) {
                lblOutput.setForeground(Color.BLACK);
                lblOutput.setText(produktgrenzlisteAktivDeaktiv.size() + " Einträge wurden erfolgreich deaktiviert");
            } else {
                lblOutput.setForeground(Color.red);
                lblOutput.setText("Nicht zulässig!");
            }

        } else {
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Nicht zulässig!");
        }
    }//GEN-LAST:event_deaktivierenProduktActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrameProduktShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrameProduktShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrameProduktShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrameProduktShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FrameProduktShow().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel Ausgabe;
    private javax.swing.JLabel Produkte;
    private javax.swing.JLabel Stueckzahl;
    private javax.swing.JScrollPane Tabelle;
    private javax.swing.JButton aktivierenProdukt;
    private javax.swing.JButton close;
    private javax.swing.JButton deaktivierenProdukt;
    private javax.swing.JTextField fieldById;
    private javax.swing.Box.Filler filler1;
    private javax.swing.JButton filterbyStueckzahl;
    private javax.swing.JButton jButton2;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JTable jTable1;
    private javax.swing.JLabel lblOutput;
    // End of variables declaration//GEN-END:variables
}
